/* print_time.c - function to print out time differences in microseconds */

#define _POSIX_C_SOURCE 200112L
#define _ISOC99_SOURCE

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include "print_time.h"


void
print_time( FILE *outfile, time_type *before, time_type *done, char *mess )
{
	int secs, fraction;
	double delta;

	secs = done->tv_sec - before->tv_sec;
	fraction = done->fraction_field - before->fraction_field;
	if (fraction < 0) {
		secs--;
		fraction += PER_SECOND;
	}
	delta = ((double)secs) + ((double)fraction)/((double)PER_SECOND);
	fprintf(outfile, "%6f%s", delta, mess);
}

/* vi: set autoindent tabstop=8 shiftwidth=8 : */
