/* print_time.h - header file for
 *		  program to print out time differences in microseconds
 */

#if defined(_POSIX_TIMERS)

	/* use the newer Posix high-resolution time facilities */
	/* must be linked on all machines with -lrt */

	#include <time.h>

	#define PER_SECOND	1000000000
	#define time_type	struct timespec
	#define fraction_field	tv_nsec
	#define get_time(where)	clock_gettime(CLOCK_REALTIME, where)

#else

	/* use the older (BSD) high-resolution time facilities */

	#include <sys/time.h>

	#define PER_SECOND	1000000
	#define time_type	struct timeval
	#define fraction_field	tv_usec
	#define get_time(where)	gettimeofday(where, NULL)

#endif



extern void
print_time( FILE *outfile, time_type *before, time_type *done, char *mess );
