/**
 * Scatterlists seem to change a lot.  Here are a bunch of macros to
 * access various fields in various kernel versions.  The version numbers
 * may be wrong for some macros... I will comment
 * them as such below, they should be fixed eventually.
 *
 * @author Ethan A. Burns
 */
#ifndef _UNH_SCATTERLIST_H_
#define _UNH_SCATTERLIST_H_

#if defined(__KERNEL__)

#include <linux/version.h>

/* This version test may not be correct... */
#if LINUX_VERSION_CODE < KERNEL_VERSION(2, 6, 24)
#define sg_virt(x) (page_address((x)->page)) + (x)->offset
#define sg_next(x) ((x) + 1)
#endif


/* version may be wrong */
#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,24)
#define for_each_sg(sg, ptr, count, index) 		\
	for ((index) = 0, (ptr) = (sg);			\
	     (index) < (count);				\
	     (index)++, (ptr)++)
#endif

/*
 * I am not sure about this macro at all.  I am copying get_sglen() in
 * target/iscsi_target.c that seems to work for now... although
 * directly accessing the lenght field also seemed to work at some
 * point too... we'll see.
 */
#define scatterlist_length(x) ((x)->length)
/*
#define scatterlist_length(x) (sg_dma_len(x))
*/

/* The offset can always be zero in the kernel since it is added on
 * automatically by sg_virt() in scatterlist_address().
 *
 * INFACT - this whole macro is kludgy.   I am not sure if this will
 *          ever be defined by kernel headers or not... it doesn't seem
 *          to be in 2.6.18 or 2.6.24-25.  I am not sure where it came
 *          from.
 */
#define scatterlist_offset(x) 0

#endif /* __KERNEL__ */

#endif /* !_UNH_SCATTERLIST_H_ */
