/*	common/user_semaphore.h -	user space version of
 *					/usr/src/linux/include/asm/sempahore.h
 *
 *	vi: set autoindent tabstop=8 shiftwidth=8 :
 *
 *	This defines the user-level interface to semaphores.
 *
 *	Copyright (C) 2001-2007 InterOperability Lab (IOL)
 *	University of New Hampshire (UNH)
 *	Durham, NH 03824
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License as published by
 *	the Free Software Foundation; either version 2, or (at your option)
 *	any later version.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
 *	USA.
 *
 *	The name of IOL and/or UNH may not be used to endorse or promote
 *	products derived from this software without specific prior
 * 	written permission.
*/

#ifndef __USER_SEMAPHORE_H__
#define __USER_SEMAPHORE_H__

#include <pthread.h>


struct semaphore {
	pthread_mutex_t mutex;
	pthread_cond_t cond;
	atomic_t count;
};

extern void sema_init(struct semaphore *s, int val);

extern void init_MUTEX_LOCKED(struct semaphore *s);

extern void init_MUTEX_UNLOCKED(struct semaphore *s);

extern int down_interruptible(struct semaphore *s);

extern void down(struct semaphore *s);

extern void up(struct semaphore *s);

#endif
