/*	common/user_signal.h -	user space version of
 *				/usr/src/linux/include/linux/signal.h
 *
 *	vi: set autoindent tabstop=8 shiftwidth=8 :
 *
 *	This defines the signal functions used
 *	by both the iSCSI target and the iSCSI initiator
 *	to run in user space instead of in the kernel.
 *
 *	Copyright (C) 2001-2007 InterOperability Lab (IOL)
 *	University of New Hampshire (UNH)
 *	Durham, NH 03824
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License as published by
 *	the Free Software Foundation; either version 2, or (at your option)
 *	any later version.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
 *	USA.
 *
 *	The name of IOL and/or UNH may not be used to endorse or promote
 *	products derived from this software without specific prior
 * 	written permission.
*/

#ifndef __USER_SIGNAL_H__
#define __USER_SIGNAL_H__

#include <signal.h>

/* from /usr/src/linux/include/linux/signal.h */
#if !defined(sigmask)
#define sigmask(sig)	(1UL << ((sig) - 1))
#endif				/* !sigmask */

/* called to unblock all the signals whose bits are set in sig_bit_mask */
extern void siginitsetinv(sigset_t * set, unsigned long sig_bit_mask);

/* returns true if any signals whose bits are set in sig_bit_mask are pending */
extern int sigtestsetmask(sigset_t * set, unsigned long sig_bit_mask);

/* removes pending signal sig */
extern void sigdelsetmask(sigset_t * set, unsigned long sig);

/* sends a signal to a task */
extern int send_sig(int, struct task_struct *, int);

#endif
