/*	common/user_timer.h -	user space version of
 *				/usr/src/linux/include/linux/timer.h
 *
 *	vi: set autoindent tabstop=8 shiftwidth=8 :
 *
 *	This defines the timer functions used
 *	by both the iSCSI target and the iSCSI initiator
 *	to run in user space instead of in the kernel.
 *
 *	Copyright (C) 2001-2007 InterOperability Lab (IOL)
 *	University of New Hampshire (UNH)
 *	Durham, NH 03824
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License as published by
 *	the Free Software Foundation; either version 2, or (at your option)
 *	any later version.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
 *	USA.
 *
 *	The name of IOL and/or UNH may not be used to endorse or promote
 *	products derived from this software without specific prior
 * 	written permission.
*/

#ifndef __USER_TIMER_H__
#define __USER_TIMER_H__

/* user space version of  /usr/src/linux/include/linux/timer.h */

struct timer_list {
	struct list_head entry;
	unsigned long expires;
	void (*function) (unsigned long);
	unsigned long data;
//              struct tvec_t_base_s    *base;
	timer_t timerid;
	int timer_active;	/* -1 not created
				   0 not active */
};

extern int timer_pending(const struct timer_list *timer);
extern void add_timer(struct timer_list *timer);
extern int del_timer_sync(struct timer_list *timer);
extern int del_timer(struct timer_list *timer);
extern void init_timer(struct timer_list *timer);


/* see /usr/src/kernel/asm/param.h */
#define HZ	100


/* see /usr/src/kernel/linux/jiffies.h */
/* extern unsigned long volatile jiffies; */

#define jiffies		((long)times(NULL))


#endif
