/*
 * Copyright (c) 2004, 2005, 2006 Voltaire, Inc. All rights reserved.
 * Copyright (c) 2007-2008 UNH InterOperability Lab
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
 * USA.
 *
 * The name IOL and/or UNH may not be used to endorse or promote
 * products derived from this software without specific prior
 * written permission.
 */

#ifndef __ISER_GLOBAL_H__
#define __ISER_GLOBAL_H__

#include "iser.h"

int iser_global_init(void);
int iser_global_release(void);

int iser_adaptor_init(struct iser_adaptor_t *iser_adaptor, char *name);
int iser_adaptor_release(struct iser_adaptor_t *iser_adaptor);

void
iser_adaptor_add_connection(struct iser_adaptor_t *p_iser_adaptor,
			    struct iser_conn_t *p_iser_conn);
struct iser_conn_t *iser_adaptor_find_connection(struct iser_adaptor_t
						 *p_iser_adaptor,
						 struct rdma_cm_id *cm_id);
void iser_adaptor_remove_connection(struct iser_conn_t *p_iser_conn);

void
iser_entity_add_connection(struct iser_entity_t *p_entity,
			   struct iser_conn_t *p_iser_conn);
void iser_entity_remove_connection(struct iser_conn_t *p_iser_conn);

char *iser_get_entity_type_name(enum iser_entity_type type);

#endif				/* __ISER_GLOBAL_H__ */
