/*
 * Copyright (c) 2004, 2005, 2006 Voltaire, Inc. All rights reserved.
 * Copyright (c) 2007-2008 UNH InterOperability Lab
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
 * USA.
 *
 * The name IOL and/or UNH may not be used to endorse or promote
 * products derived from this software without specific prior
 * written permission.
 */

#ifndef __ISER_MEMORY_H__
#define __ISER_MEMORY_H__

#include "iser.h"

/** Size of the snd_recv_data_mem_cache blocks. */
#define SND_RECV_DATA_SIZE 8192

/** Maximum number of registered buffers to store in each cache. */
#define PRE_REGD_CACHE_MAX_DEFAULT 100

void iser_init_regd_buf_caches(struct iser_conn_t *p_conn);
void iser_release_regd_buf_caches(struct iser_conn_t *p_conn);

struct iser_regd_buf_t *iser_buffer_alloc(unsigned long,
					  struct iser_conn_t *,
                                          enum dma_data_direction);
int iser_buffer_free(struct iser_regd_buf_t *p_entry);

/* ---------------------------------------------------------------------
 * REGISTERED BUFFERS HANDLING
 * ------------------------------------------------------------------ */

int iser_regd_buff_reference(struct iser_regd_buf_t *p_regd_buf);

int iser_regd_buff_dereference(struct iser_regd_buf_t *p_regd_buf);

int
iser_regd_buff_release(struct iser_regd_buf_t *p_regd_buf,
		       int *release_deferred);

struct iser_regd_buf_t *iser_alloc_regd_buf(void);
void iser_free_regd_buf(struct iser_regd_buf_t *);


#endif				/* __ISER_MEMORY_H__ */
