/*
 * Copyright (c) 2004, 2005, 2006 Voltaire, Inc. All rights reserved.
 * Copyright (c) 2007-2008 UNH InterOperability Lab
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
 * USA.
 *
 * The name IOL and/or UNH may not be used to endorse or promote
 * products derived from this software without specific prior
 * written permission.
 */

#ifndef __ISER_PROCFS_H__
#define __ISER_PROCFS_H__

#include "iser.h"

int iser_procfs_init(void);
int iser_procfs_cleanup(void);

int iser_procfs_add_entity(struct iser_entity_t *p_entity);
int iser_procfs_delete_entity(struct iser_entity_t *p_entity);

int iser_procfs_add_adaptor(struct iser_adaptor_t *p_iser_adaptor);
int iser_procfs_delete_adaptor(struct iser_adaptor_t *p_iser_adaptor);

int iser_procfs_add_connection(struct iser_conn_t *p_iser_conn);
int iser_procfs_delete_connection(struct iser_conn_t *p_iser_conn);

/* Generic procfs "long read" handling - callbacks */
typedef char *(*read_proc_buf_func_t) (int *);
typedef void (*read_proc_free_buf_func_t) (char *);

#endif				/* __ISER_PROCFS_H__ */
