/*
 * Copyright (c) 2004, 2005, 2006 Voltaire, Inc. All rights reserved.
 * Copyright (c) 2007-2008 UNH InterOperability Lab
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
 * USA.
 *
 * The name IOL and/or UNH may not be used to endorse or promote
 * products derived from this software without specific prior
 * written permission.
 */

#ifndef __ISER_TARGET_H__
#define __ISER_TARGET_H__

#include "iser.h"

/* Target-specific Functions */

int
iser_target_register_entity(struct iser_entity_t *p_entity,
			    struct iser_api_t *api,
			    struct iser_ext_api_t *ext_api,
			    struct iser_ext_api_cb_t *ext_api_cb,
			    struct sockaddr *addr, size_t addr_len);

int
iser_target_handle_connection_request(struct iser_conn_t *p_conn,
				      struct sockaddr *local_addr);

/* Target-specific definitions */

#define ISER_TARGET_MAX_RX_MISC_PDUS        (ISER_MAX_TEXT_REQ + ISER_MAX_NOP_OUT + ISER_MAX_TASK_MGT_REQ + ISER_MAX_LOGOUT_REQ + ISER_MAX_LOGIN_REQ)
#define ISER_TARGET_MAX_TX_CMD_RESP         ISER_MAX_OUTSTAND_CMDS
#define ISER_TARGET_MAX_RDMA_IN             ISER_MAX_OUTSTAND_CMDS
#define ISER_TARGET_MAX_RDMA_OUT            ISER_MAX_OUTSTAND_CMDS

/* EP settings */
// allocate 10 PRBs for immediate commands
#define ISER_TARGET_AVG_TASK_RELATED_RECV(first_burst, recv_dsl, imm, max_cmds) \
                                            (max_cmds * ISER_MAX_CTRLS_PER_CMD(first_burst,recv_dsl,imm) + 10 )

#define ISER_TARGET_EP_MAX_RECV_DTOS        64
#define ISER_TARGET_EP_MAX_REQ_DTOS         (ISER_TARGET_MAX_TX_CMD_RESP + ISER_TARGET_MAX_RDMA_IN + ISER_TARGET_MAX_RDMA_OUT + ISER_TARGET_MAX_RX_MISC_PDUS + 4)

/* global EVD settings - per entity */
#define ISER_TARGET_EVD_MAX_RECV_DTOS       (ISER_TARGET_EP_MAX_RECV_DTOS * ISER_TARGET_MAX_CONN)
#define ISER_TARGET_EVD_MAX_REQ_DTOS        (ISER_TARGET_EP_MAX_REQ_DTOS * ISER_TARGET_MAX_CONN)

#define ISER_TARGET_MAX_QLEN                (ISER_TARGET_EVD_MAX_RECV_DTOS + ISER_TARGET_EVD_MAX_REQ_DTOS)

#endif				/* __ISER_TASK_H__ */
