/*
 * Copyright (c) 2004, 2005, 2006 Voltaire, Inc. All rights reserved.
 * Copyright (c) 2007-2008 UNH InterOperability Lab
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
 * USA.
 *
 * The name IOL and/or UNH may not be used to endorse or promote
 * products derived from this software without specific prior
 * written permission.
 */

#ifndef __ISER_TASK_H__
#define __ISER_TASK_H__

#include "iser.h"

/* iSER API Functions */

iser_status_t iser_deallocate_task_resources(iser_conn_handle_t conn_h,
					     unsigned int itt);
/* Internal iSER Functions */

struct iser_task_t *iser_task_alloc(struct iser_conn_t *iser_conn,
				    unsigned int itt);
void iser_task_ctrl_notify_count_inc(struct iser_task_t *p_iser_task);

int
iser_task_ctrl_notify_count_dec_and_test(struct iser_task_t *p_iser_task);

void iser_task_post_send_count_inc(struct iser_task_t *p_iser_task);

int
iser_task_post_send_count_dec_and_test(struct iser_task_t *p_iser_task);

void iser_task_recvd_pdu_count_inc(struct iser_task_t *p_iser_task);

int iser_task_recvd_pdu_count_reset(struct iser_task_t *p_iser_task);

void
iser_task_set_status(struct iser_task_t *p_iser_task,
		     enum iser_task_status_t status);
void iser_task_free(struct iser_task_t *iser_task);

void iser_task_release_recv_buffers(struct iser_task_t *p_iser_task);

void iser_task_release_send_buffers(struct iser_task_t *p_iser_task);

#endif				/* __ISER_TASK_H__ */
