/*
 * Copyright (c) 2004, 2005, 2006 Voltaire, Inc. All rights reserved.
 * Copyright (c) 2007-2008 UNH InterOperability Lab
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
 * USA.
 *
 * The name IOL and/or UNH may not be used to endorse or promote
 * products derived from this software without specific prior
 * written permission.
 */

#if defined(__KERNEL__)
#include <linux/module.h>
#include <linux/kernel.h>
#else
//#include <dat/udat.h>
#include "../common/user_space.h"
#endif				/* __KERNEL__ */

#include "iser_platform.h"

extern int iser_fmr_enabled;

void *iser_platform_pci_addr(void *addr)
{
	return (addr);
}

uint64_t iser_platform_read_cpu_ticks()
{
	uint32_t lo, hi;

	__asm__ __volatile__("rdtsc":"=a"(lo), "=d"(hi));
	return ((uint64_t) hi << 32) | (uint64_t) lo;
}
