#ifndef ISER_INIT_H
#define ISER_INIT_H

int recv_control_notifications(struct connection *current_connection,
			       char **buffer, int *received, int flag);
void free_buffer(struct connection *current_connection, char **buffer);
void free_iser_login_buffer(struct connection *current_connection,
			    __u32 flags, struct generic_pdu *inpdu);

#ifdef RDMA_MODE
void control_terminate_notify(iser_conn_handle_t cid);
void control_notify(iser_conn_handle_t cid,
		    struct iser_recv_pdu_t *p_ctrl_pdu);
iser_status_t connection_establish_notify(iser_conn_handle_t cid,
					  int established);
void send_notify(iser_conn_handle_t cid);

void iser_dequeue_pdu(struct connection *conn_p);
void iser_front_pdu(struct connection *conn_p,
                    struct iser_recv_pdu_t **pdu_p);
#endif
int iser_alloc_conn_resources(struct connection *conn,
			      struct parameter_type
			      p_param_tbl[MAX_CONFIG_PARAMS]);
int iser_dealloc_conn_resources(struct connection *conn);
int iser_enable_datamover(struct connection *conn);
void iser_conn_terminate(struct connection *conn);

#endif
