#ifndef _ISER_TARGET_H_
#define _ISER_TARGET_H_

#ifdef RDMA_MODE
void control_notify(iser_conn_handle_t cid,
		    struct iser_recv_pdu_t *p_ctrl_pdu);
void command_notify(iser_conn_handle_t conn_h,
		    struct iser_recv_pdu_t *p_ctrl_pdu, void *iser_task_h,
		    void **iscsi_task_h);
void control_terminate_notify(iser_conn_handle_t cid);
void send_notify(iser_conn_handle_t cid);
struct iscsi_conn *find_targ_conn_by_iser_handle(void *iser_conn_handle);
void data_completion_notify(void *iscsi_task_h, int itt, int sn);
void data_ack_notify(void *iscsi_task_h, int itt, int data_sn);
iser_status_t connection_establish_notify(iser_conn_handle_t cid_h,
					  int established);
iser_status_t connection_request_notify(iser_conn_request_t conn_req_h,
					struct sockaddr_in *dst_addr,
					struct sockaddr_in *src_addr);
void iser_dequeue_pdu(struct iscsi_conn *conn_p);
void iser_front_pdu(struct iscsi_conn *conn_p,
		    struct iser_recv_pdu_t **rx_pdu_buff,
		    void **rx_task_buff);
#endif				/* RDMA_MODE */

int recv_target_control_notifications(struct iscsi_conn *conn,
				      __u8 ** pdu_bhs,
				      __u8 ** data_buffer);
void free_iser_login_buffer(struct iscsi_conn *conn,
			    struct generic_pdu *inpdu);
void free_queued_targ_buf(struct iscsi_cmnd *cmnd, char **, void **);
void free_targ_buf(struct iscsi_conn *conn, __u8 ** bhs, __u8 ** buffer);
void targ_release_control(struct iscsi_conn *conn, __u8 ** bhs,
			  __u8 ** buffer);

int iser_alloc_conn_resources(struct iscsi_conn *conn,
			      struct parameter_type
			      p_param_tbl[MAX_CONFIG_PARAMS]);
int iser_dealloc_conn_resources(struct iscsi_conn *conn);
int iser_enable_datamover(struct iscsi_conn *conn, struct generic_pdu *);
int iser_conn_terminate(struct iscsi_conn *conn);

int iser_bring_up_portal(struct portal_group *ptr);

#endif				/* _ISER_TARGET_H_ */
