/*
 *	Copyright (C) 2001-2007 InterOperability Lab (IOL)
 *	University of New Hampshire (UNH)
 *	Durham, NH 03824
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License as published by
 *	the Free Software Foundation; either version 2, or (at your option)
 *	any later version.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
 *	USA.
 *
 *	The name of IOL and/or UNH may not be used to endorse or promote
 *	products derived from this software without specific prior
 *	written permission.
 *
 * target/scsi_midlevel.h -- Contains function declarations for the SCSI
 * Mid-Level callbacks
 *
 * Created Thu Mar  1 11:06:48 2007 -- Ethan Burns
 */
#ifndef _SCSI_MIDLEVEL_H_
#define _SCSI_MIDLEVEL_H_

#include "scsi_target.h"

int iscsi_detect(Scsi_Target_Template * tmpt);
int iscsi_release(Scsi_Target_Device * device);
int iscsi_xmit_response(Target_Scsi_Cmnd * cmnd);
int iscsi_rdy_to_xfer(Target_Scsi_Cmnd * cmnd);
int iscsi_proc_info(char *buffer, char **start, off_t offset,
		    int length, int inode, int inout);
void iscsi_task_mgt_fn_done(Target_Scsi_Message * msg);

#endif				/* _SCSI_MIDLEVEL_H_ */
/* vi: set tabstop=8 textwidth=78: */
